jQuery( function( $ ) {

  /**
   * Breaking News
   */
  $( function() {
    'use strict';

    /**
     * Setup ajax.
     */
    $.ajax( {
      type: 'GET',
      url: tpdLiveBannerGlobal.site_url_homepage + '/wp-json/livebanner/v1/get_active_banner',

      success: function( data ) {

        /**
         * IF live banner is active
         */
        var start_date = data.post_published_date;
        var end_date = moment.unix( start_date ).add( data.live_banner_duration, 'minutes' ).unix();        
        var current_time = moment().unix();
        var lb_active = false;
        if ( start_date < current_time && current_time < end_date ) {
          lb_active = true;
        } else {
          return;
        }

        // IF show mobile and is mobile
        var isMobile = window.matchMedia("only screen and (max-width: 760px)").matches;
        if ( (isMobile && data.display_on == "desktop") || (!isMobile && data.display_on == "mobile") ) {
          return;
        }

        var insert_live_banner = function() {
          var position_parent = ( data.customSelector ) ? data.customSelector : 'body';
          var position_placement = ( data.customSelectorBA == 'after' ) ? 'append' : 'prepend' ;
          if ( position_placement == 'append' ) {
            $( position_parent ).append( data.content ).addClass( 'has-tpd-live-banner' );
          } else {
            $( position_parent ).prepend( data.content ).addClass( 'has-tpd-live-banner' );
          }

          // IF fullsite ad takeover then move live-banner after navigation
          // (inside the content container) 
          if ( $("body.single").length == 0 ) {
            var banner_moved = false;
            window.googletag = window.googletag || {};
            window.googletag.cmd = window.googletag.cmd || [];
            window.googletag.cmd.push( function() {
                googletag.pubads().addEventListener( 'slotRenderEnded',
                    function( event ) {
                        var slot = event.slot;
                        // if ( slot.getSlotElementId().includes( 'skin-ad' ) && slot.getHtml().includes( 'GenecyDFPAdWallpaper' ) ) {     
                        if ( slot.getSlotElementId().includes( 'skin-ad' ) ) {     
                          if ( !banner_moved ) {
                            banner_moved = true;
                            document.body.classList.add( 'tpd-has-takeover' );
                            $(".wp-block-tpd-block-tpd-live-banner").appendTo(".site-header");
                          }
                        }
                    }
                );  
            } );
          } else {
            var banner_moved = false;
            window.googletag = window.googletag || {};
            window.googletag.cmd = window.googletag.cmd || [];
            window.googletag.cmd.push( function() {
                googletag.pubads().addEventListener( 'slotRenderEnded',
                    function( event ) {
                        var slot = event.slot;
                        // if ( slot.getSlotElementId().includes( 'skin-ad' ) && slot.getHtml().includes( 'GenecyDFPAdWallpaper' ) ) {     
                        if ( slot.getSlotElementId().includes( 'skin-ad' ) ) {     
                          if ( !banner_moved ) {
                            banner_moved = true;
                            document.body.classList.add( 'tpd-has-takeover' );
                            $("header#header").css('flex-wrap','wrap');
                            $(".wp-block-tpd-block-tpd-live-banner").appendTo(".site-header").css('flex-basis','100%');
                          }
                        }
                    }
                );  
            } );
          }

        };

        /**
         * Add banner content.
         */
        if ( data.showOnlyOnHomepage ) {
          if ( data.homepage_url == window.location.href.slice( 0, -1 ) || data.homepage_url == window.location.href ) {
            insert_live_banner();
          }
        } else {
          insert_live_banner();
        }

        /**
         * Load livebanner global scripts and CSS
         */
        $( 'body' ).append( '<s type="text/javascript" src="' + data.script_url + '"></s>' );
        $( 'head' ).append( '<link rel="stylesheet" id="tpd-live-banner-style" href="' + data.style_url + '" media="all">' );

        /**
         * Load custom scripts depending on the template selected
         */
        /**
         * * Template #1
         */
        if ( data.template == '1' ) {
          $( 'head' ).append( '<link rel="stylesheet" id="tpd-live-banner-style" href="' + data.t1_plyr_style + '" media="all">' );
          $( 'body' ).append( '<s type="text/javascript" src="' + data.t1_html5media + '"></s>' );
          // $( 'body' ).append( '<s type="text/javascript" src="' + data.t1_plyr_script + '"></s>' );
          $( 'body' ).append( '<style>.wp-block-tpd-block-tpd-live-banner .template-1 .plyr__controls__item.plyr__control { background:'+data.playButtonBackground+'; color:'+data.playButtonColor+' }</style>' );
          activatePlyr( '#listen-live-audio', [ 'play', 'volume', 'controls' ] );
        
          if ($(window).width() < 980) {
              
          } else {

            //adding continuous play when navigating to different pages, at least to the extent that browsers allow
            var singleLiveAudio = document.querySelector( '#listen-live-audio' );
            $(singleLiveAudio).prop('muted', true);
            $(singleLiveAudio).prop('autoplay', true);

            if(sessionStorage.getItem("autop") === null)
            {
              $('body').addClass('no-autoplay');
              singleLiveAudio.pause();
            }//end if sessionstorage autop does not exist

            if(sessionStorage.getItem("autop") === 'true') 
            {
              var mousemoveListener = function (e) {
                var promise = document.querySelector('#listen-live-audio').play();
                if (promise !== undefined) {
                  promise.then(_ => {
                      $(singleLiveAudio).prop('muted', false);
                      $(singleLiveAudio).prop('autoplay', true);
                      singleLiveAudio.play();
                  }).catch(error => {
                    console.log(error);
                    e.stopPropagation();
                    if ($('.plyr--audio').find('.refresh-error').length == 0) {
                      $('.plyr--audio').append($("<div class='refresh-error' onclick='document.getElementById(`listen-live-audio`).play(); this.remove();' style='cursor:pointer;position: absolute;padding:5px;width: 100%;height: 100%;background: rgba(0,0,0,0.75);top: 0;font-size: 12px;text-align: center;z-index: 99;display: flex;align-items: center;border-radius: 10px;'>Page refreshed. Please click here to resume your audio.</div>"));
                      document.body.removeEventListener("mousemove", mousemoveListener);
                    }
                  });   
                }
              };
              document.body.addEventListener("mousemove", mousemoveListener);
              $('body').addClass('autoplay');
            }//end if sessionstorage autop exists

            $( ".no-autoplay .plyr__control" ).click(function() {
              sessionStorage.setItem('autop', 'true');
            });//end set sessionstorage autop to true when play is clicked

            $( ".autoplay .plyr__control" ).click(function() {
              singleLiveAudio.pause();
              sessionStorage.removeItem('autop');
              sessionStorage.clear();
              document.body.removeEventListener("mousemove", mousemoveListener);
              // location.reload();
            });//end remove and clear sessionstorage when pause is clicked
          }
        }

        /**
         * * Template #2
         */
        if ( data.template == '2' ) {
          $( 'head' ).append( '<link rel="stylesheet" id="tpd-live-banner-style" href="' + data.t2_plyr_style + '" media="all">' );
          $( 'body' ).append( '<script type="text/javascript" src="' + data.t2_plyr_script + '"></script>' );
          // Get CSS of background and color
          var tpdScrollBannerBackground = document.querySelector( '.template-2 > div' ).style.background;
          // Write dynamic CSS
          var tpdScrollBannerStyle = '<style>.template-2.scroll-text > div .the_news:after { background: linear-gradient(to right, transparent 0%, transparent 15%, ' + tpdScrollBannerBackground + ' 85%, ' + tpdScrollBannerBackground + ' 100%)!important; }</style>';
          // Append dynamic CSS
          $( 'head' ).append( tpdScrollBannerStyle );
        }

        /**
         * * Template #3
         */
        if ( data.template == '3' ) {

          $( 'head' ).append( '<link rel="stylesheet" id="tpd-live-banner-style" href="' + data.t3_plyr_style + '" media="all">' );
          $( 'body' ).append( '<script type="text/javascript" src="' + data.t3_html5media + '"></script>' );
          $( 'body' ).append( '<script type="text/javascript" src="' + data.t3_plyr_script + '"></script>' );
          $( 'body' ).append( '<style>.wp-block-tpd-block-tpd-live-banner .template-3 .tpd-live-banner-play-button { background:'+data.playButtonBackground+' } svg.tpd-live-banner-play-button__play path {fill:'+data.playButtonColor+'}</style>' );

          $.ajax( {
            type: 'GET',
            url: tpdLiveBannerGlobal.site_url_homepage + '/wp-json/livebanner/v1/get_omny_feed?id=' + data.id,
            success: function( omny_data ) {

                // Get CSS of background and color
                var tpdLiveBannerBackground = (document.querySelector( '.wp-block-tpd-block-tpd-live-banner' )) ? document.querySelector( '.wp-block-tpd-block-tpd-live-banner' ).style.background : "#000" ;
                var tpdLiveBannerColor = (document.querySelector( '.tpd-live-banner' )) ? document.querySelector( '.tpd-live-banner' ).style.color : "#fff" ;

                // Write dynamic CSS
                var tpdLiveBannerStyle = '<style>.tpd-live-banner__button button { color: ' + tpdLiveBannerColor + '; } .tpd-live-banner__button button svg { fill: ' + tpdLiveBannerColor + '; } .tpd-live-banner__playlist { background: ' + tpdLiveBannerBackground + '; }</style>';

                // Append dynamic CSS
                $( 'head' ).append( tpdLiveBannerStyle );

                var plyr_shift = $( '<div class="plyr__controls__item plyr__shift"></div>' );
                var forward_button = '<button class="tpd-live-banner-forward-button"><svg aria-hidden="true" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" fill="' + tpdLiveBannerColor + '"><path d="M500.5 231.4l-192-160C287.9 54.3 256 68.6 256 96v320c0 27.4 31.9 41.8 52.5 24.6l192-160c15.3-12.8 15.3-36.4 0-49.2zm-256 0l-192-160C31.9 54.3 0 68.6 0 96v320c0 27.4 31.9 41.8 52.5 24.6l192-160c15.3-12.8 15.3-36.4 0-49.2z"></path></svg></button>';
                var rewind_button = '<button class="tpd-live-banner-rewind-button"><svg aria-hidden="true" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" fill="' + tpdLiveBannerColor + '"><path d="M11.5 280.6l192 160c20.6 17.2 52.5 2.8 52.5-24.6V96c0-27.4-31.9-41.8-52.5-24.6l-192 160c-15.3 12.8-15.3 36.4 0 49.2zm256 0l192 160c20.6 17.2 52.5 2.8 52.5-24.6V96c0-27.4-31.9-41.8-52.5-24.6l-192 160c-15.3 12.8-15.3 36.4 0 49.2z"></path></svg></button>';

                plyr_shift.append( rewind_button ).append( forward_button );

                plyr_shift.insertAfter( '.tpd-live-banner .plyr__progress__container' );

                // Create playlist element
                var playlistElement = $( '<nav class="tpd-live-banner__playlist"><ul></ul></nav>' );

                // Insert playlist element
                $( '.tpd-live-banner' ).append( playlistElement );

                if ( omny_data ) {

                  var firstClick = true;

                  //   // Setup first clip
                  //   $( '#listen-live-audio' ).attr( 'src', omny_data[0].audio );
                  var title_limited = omny_data[0].title;
                  if ( title_limited.length > 111 ) {
                    title_limited = title_limited.substring(0, 112) + "...";
                  }
                  $( '.tpd-live-banner-title' ).append( '<h5>' + title_limited + '</h5>' );

                  // Loop through all clips
                  for ( var i = 0; i < omny_data.length; i++ ) {
                    var audio = omny_data[ i ].audio;
                    var duration = omny_data[ i ].duration;
                    var title = omny_data[ i ].title;

                    var duration = new Date( duration * 1000 ).toISOString().substr( 11, 8 );

                    // If less than 1 hour remove "00:" from string
                    if ( duration.substring( 0, 3 ) == '00:' ) {
                      duration = duration.substring( 3 );
                    }

                    var li = $( '<li><a data-audio-url="' + audio + '" href="#' + title + '" title="' + title + '"><span class="clip-title">' + title + '</span> <span class="clip-duration">' + duration + '</span></a></li>' );

                    $( '.tpd-live-banner__playlist ul' ).append( li );
                  }
                }

                var clickPlyr = function() {
                  activatePlyr( '#listen-live-audio', [ 'play', 'current-time', 'progress', 'mute', 'volume' ] );
                  $( '[data-plyr="play"]' ).click();

                  var listenLiveAudio = document.querySelector( '#listen-live-audio' );

                  if ( isPlaying( listenLiveAudio ) ) {
                    $( '.tpd-live-banner-play-button' ).addClass( 'is-playing' ).removeClass( 'is-paused' );
                  } else {
                    $( '.tpd-live-banner-play-button' ).addClass( 'is-paused' ).removeClass( 'is-playing' );
                  }
                };

                // Detect click outside of button
                $( document ).on( 'click touchend', function( e ) {
                  var playlistElement = $( '.tpd-live-banner__playlist' );
                  if ( e.target.closest( '.tpd-live-banner__button, .tpd-live-banner__playlist' ) ) {
                    return;
                  }
                  playlistElement.add( '.tpd-live-banner__button' ).removeClass( 'is-open' );
                } );

                // Click action for play button
                $( '.tpd-live-banner-play-button' ).on( 'click', function() {

                  // Set transition here because with CSS it shows on page load.
                  $( '.tpd-live-banner-play-button .tpd-live-banner-play-button__pause, .tpd-live-banner-play-button .tpd-live-banner-play-button__play' ).css( 'transition', '.125s all ease-out' );
                  $( '.plyr__tooltip' ).css( 'transition', 'opacity .2s .1s ease, transform .2s .1s ease' );

                  // initialize first track here so it doesn't preloads the file
                  if ( firstClick ) {
                    $( '#listen-live-audio' ).attr( 'src', omny_data[0].audio );
                    firstClick = false;
                  }

                  clickPlyr();
                } );

                // Click action for playlist button
                $( '.tpd-live-banner__button > button' ).on( 'click', function() {
                  $( '.tpd-live-banner__playlist' ).css( 'transition', 'all .125s ease-out' );

                  if ( $( '.tpd-live-banner__playlist' ).hasClass( 'is-open' ) ) {
                    $( this ).parent().removeClass( 'is-open' );
                    $( '.tpd-live-banner__playlist' ).removeClass( 'is-open' );
                  } else {
                    $( this ).parent().addClass( 'is-open' );
                    $( '.tpd-live-banner__playlist' ).addClass( 'is-open' );
                  }
                } );

                // Click action for playlist item
                $( '.tpd-live-banner__playlist a[data-audio-url]' ).on( 'click', function( e ) {
                  e.preventDefault();

                  var title_limited_update = $( this ).attr( 'title' );
                  if ( title_limited_update.length > 90 ) {
                    title_limited_update = title_limited_update.substring(0, 90) + "...";
                  }

                  var audio_title = title_limited_update;
                  var audio_url = $( this ).attr( 'data-audio-url' );
                  var listenLiveAudio = $( '#listen-live-audio' );
                  var listenLiveTitle = $( '.tpd-live-banner-title > h5' );

                  listenLiveAudio.attr( 'src', audio_url );
                  listenLiveTitle.text( audio_title );

                  clickPlyr();
                } );

            }
          });

        }//if template 3

        // helper functions
        function activatePlyr( element, controls ) {
          if ( $( element ).length ) {
            var supportsAudio = !!document.createElement( 'audio' ).canPlayType;
            if ( supportsAudio ) {
              var player = new Plyr( element, {
                controls: controls
              } );
      
              $( document ).on( 'click', '.tpd-live-banner-forward-button', function( e ) {
                e.preventDefault();
      
                player.forward( 10 );
              } );
      
              $( document ).on( 'click', '.tpd-live-banner-rewind-button', function( e ) {
                e.preventDefault();
      
                player.rewind( 10 );
              } );
            } else {
              console.log( 'Sorry, your browser does not support audio.' );
            }
          }
        };
        function isPlaying( audio ) {
          return ! audio.paused;
        }

        setTimeout( function() {
          $(".wp-block-tpd-block-tpd-live-banner").css("opacity", 1);
          $(".wp-block-tpd-block-tpd-live-banner").css("height", "auto");

          // IF Mobile adjust position
          if ( isMobile ) {
            var b_h = document.querySelector('.wp-block-tpd-block-tpd-live-banner').clientHeight;
            var h_h = $("header#header").outerHeight();
            $("header#header").css( "min-height", b_h + h_h + "px" );
            $(".wp-block-tpd-block-tpd-live-banner").appendTo("header#header").css({
              'position' : 'absolute',
              'bottom' : '0',
              'width' : '100%',
              'height' : b_h+'px',
              'top' : h_h+'px'
            });
            $(".template-1, .template-2, .template-3").css({
              'position' : 'absolute',
              'bottom' : '0'
            });
          }

        }, 500)
          

      }
    } );
  } );
} );